using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;   // For the DllImport of TcC Driver API

namespace TcCNet
{
	public class TcC
	{
		[UnmanagedFunctionPointer(CallingConvention.StdCall)]
		public delegate void TScanVCallback(IntPtr pData, UInt32 DataSize);

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="TcC_StartAcquisition")]
		public static extern UInt32 StartAcquisition(CallbackHz: Double; pCallback: TPScanVCallback);

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall), EntryPoint="TcC_StopAcquisition"]
		public static extern UInt32 StopAcquisition();

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
		public static extern UInt32 TcC_ConfigureChannels(StringBuilder pConfigStr, UInt32 ConfigStrSize)

		public static extern UInt32 ConfigureChannels(String ConfigStr)
		{
			UInt32 ConfigStrSize = Convert.ToUInt32(ConfigStr.Length);
			TcC_ConfigureChannels(new StringBuilder(ConfigStr), ConfigStrSize);
		}

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
		public static extern void TcC_StrFromErrorCode(UInt32 ErrorCode, StringBuilder pErrorStr, [In, Out] UInt32 pErrorStrSize);

		public static extern String StrFromErrorCode(UInt32 ErrorCode)
		{
			UInt32 ErrorStrSize;
			StringBuilder ErrorStr;

			ErrorStrSize = 0;
			TcC_ErrorCodeStr(ErrorCode, NULL, ErrorStrSize);
			StringBuilder ErrorStr = new StringBuilder(ErrorStrSize);
			TcC_ErrorCodeStr(ErrorCode, ErrorStr, ErrorStrSize);
			return ErrorStr.ToString(0, ErrorStrSize);
		}

		[DllImport("TCC.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="TcC_ConfigureBreakDetect")]
		public static extern UInt32 ConfigureBreakDetect(Double MaxMillivolts, Double Sentinel);
	}
}

